import {
    epsilon, splitter, resulterrbound, estimate, vec,
    fast_expansion_sum_zeroelim, scale_expansion_zeroelim
} from './util.js';

const iccerrboundA = (10 + 96 * epsilon) * epsilon;
const iccerrboundB = (4 + 48 * epsilon) * epsilon;
const iccerrboundC = (44 + 576 * epsilon) * epsilon * epsilon;

const bc = vec(4);
const ca = vec(4);
const ab = vec(4);
const axbc = vec(8);
const axxbc = vec(16);
const aybc = vec(8);
const ayybc = vec(16);
const adet = vec(32);
const bxca = vec(8);
const bxxca = vec(16);
const byca = vec(8);
const byyca = vec(16);
const bdet = vec(32);
const cxab = vec(8);
const cxxab = vec(16);
const cyab = vec(8);
const cyyab = vec(16);
const cdet = vec(32);
const abdet = vec(64);
const fin1 = vec(1152);
const fin2 = vec(1152);
const aa = vec(4);
const bb = vec(4);
const cc = vec(4);
const u = vec(4);
const v = vec(4);
const temp8 = vec(8);
const temp16a = vec(16);
const temp16b = vec(16);
const temp16c = vec(16);
const temp32a = vec(32);
const temp32b = vec(32);
const temp48 = vec(48);
const temp64 = vec(64);
const axtbb = vec(8);
const axtcc = vec(8);
const aytbb = vec(8);
const aytcc = vec(8);
const bxtaa = vec(8);
const bxtcc = vec(8);
const bytaa = vec(8);
const bytcc = vec(8);
const cxtaa = vec(8);
const cxtbb = vec(8);
const cytaa = vec(8);
const cytbb = vec(8);
const axtbc = vec(8);
const aytbc = vec(8);
const bxtca = vec(8);
const bytca = vec(8);
const cxtab = vec(8);
const cytab = vec(8);
const axtbct = vec(16);
const aytbct = vec(16);
const bxtcat = vec(16);
const bytcat = vec(16);
const cxtabt = vec(16);
const cytabt = vec(16);
const axtbctt = vec(8);
const aytbctt = vec(8);
const bxtcatt = vec(8);
const bytcatt = vec(8);
const cxtabtt = vec(8);
const cytabtt = vec(8);
const abt = vec(8);
const bct = vec(8);
const cat = vec(8);
const abtt = vec(4);
const bctt = vec(4);
const catt = vec(4);

function incircleadapt(ax, ay, bx, by, cx, cy, dx, dy, permanent) {
    let bdxcdy1, cdxbdy1, cdxady1, adxcdy1, adxbdy1, bdxady1;
    let bdxcdy0, cdxbdy0, cdxady0, adxcdy0, adxbdy0, bdxady0;
    let bc3, ca3, ab3;
    let finnow, finother, finswap, finlength;

    let adxtail, bdxtail, cdxtail, adytail, bdytail, cdytail;
    let adxadx1, adyady1, bdxbdx1, bdybdy1, cdxcdx1, cdycdy1;
    let adxadx0, adyady0, bdxbdx0, bdybdy0, cdxcdx0, cdycdy0;
    let aa3, bb3, cc3;
    let ti1, tj1;
    let ti0, tj0;
    let u3, v3;
    let temp8len, temp16alen, temp16blen, temp16clen;
    let temp32alen, temp32blen, temp48len, temp64len;
    let axtbblen, axtcclen, aytbblen, aytcclen;
    let bxtaalen, bxtcclen, bytaalen, bytcclen;
    let cxtaalen, cxtbblen, cytaalen, cytbblen;
    let axtbclen, aytbclen, bxtcalen, bytcalen, cxtablen, cytablen;
    let axtbctlen, aytbctlen, bxtcatlen, bytcatlen, cxtabtlen, cytabtlen;
    let axtbcttlen, aytbcttlen, bxtcattlen, bytcattlen, cxtabttlen, cytabttlen;
    let abtlen, bctlen, catlen;
    let abttlen, bcttlen, cattlen;
    let abtt3, bctt3, catt3;
    let negate;

    let bvirt, c, ahi, alo, bhi, blo, _i, _j, _0;

    const adx = ax - dx;
    const bdx = bx - dx;
    const cdx = cx - dx;
    const ady = ay - dy;
    const bdy = by - dy;
    const cdy = cy - dy;

    bdxcdy1 = bdx * cdy;
    c = splitter * bdx;
    ahi = c - (c - bdx);
    alo = bdx - ahi;
    c = splitter * cdy;
    bhi = c - (c - cdy);
    blo = cdy - bhi;
    bdxcdy0 = alo * blo - (bdxcdy1 - ahi * bhi - alo * bhi - ahi * blo);
    cdxbdy1 = cdx * bdy;
    c = splitter * cdx;
    ahi = c - (c - cdx);
    alo = cdx - ahi;
    c = splitter * bdy;
    bhi = c - (c - bdy);
    blo = bdy - bhi;
    cdxbdy0 = alo * blo - (cdxbdy1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = bdxcdy0 - cdxbdy0;
    bvirt = bdxcdy0 - _i;
    bc[0] = bdxcdy0 - (_i + bvirt) + (bvirt - cdxbdy0);
    _j = bdxcdy1 + _i;
    bvirt = _j - bdxcdy1;
    _0 = bdxcdy1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - cdxbdy1;
    bvirt = _0 - _i;
    bc[1] = _0 - (_i + bvirt) + (bvirt - cdxbdy1);
    bc3 = _j + _i;
    bvirt = bc3 - _j;
    bc[2] = _j - (bc3 - bvirt) + (_i - bvirt);
    bc[3] = bc3;
    const axbclen = scale_expansion_zeroelim(4, bc, adx, axbc);
    const axxbclen = scale_expansion_zeroelim(axbclen, axbc, adx, axxbc);
    const aybclen = scale_expansion_zeroelim(4, bc, ady, aybc);
    const ayybclen = scale_expansion_zeroelim(aybclen, aybc, ady, ayybc);
    const alen = fast_expansion_sum_zeroelim(axxbclen, axxbc, ayybclen, ayybc, adet);

    cdxady1 = cdx * ady;
    c = splitter * cdx;
    ahi = c - (c - cdx);
    alo = cdx - ahi;
    c = splitter * ady;
    bhi = c - (c - ady);
    blo = ady - bhi;
    cdxady0 = alo * blo - (cdxady1 - ahi * bhi - alo * bhi - ahi * blo);
    adxcdy1 = adx * cdy;
    c = splitter * adx;
    ahi = c - (c - adx);
    alo = adx - ahi;
    c = splitter * cdy;
    bhi = c - (c - cdy);
    blo = cdy - bhi;
    adxcdy0 = alo * blo - (adxcdy1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = cdxady0 - adxcdy0;
    bvirt = cdxady0 - _i;
    ca[0] = cdxady0 - (_i + bvirt) + (bvirt - adxcdy0);
    _j = cdxady1 + _i;
    bvirt = _j - cdxady1;
    _0 = cdxady1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - adxcdy1;
    bvirt = _0 - _i;
    ca[1] = _0 - (_i + bvirt) + (bvirt - adxcdy1);
    ca3 = _j + _i;
    bvirt = ca3 - _j;
    ca[2] = _j - (ca3 - bvirt) + (_i - bvirt);
    ca[3] = ca3;
    const bxcalen = scale_expansion_zeroelim(4, ca, bdx, bxca);
    const bxxcalen = scale_expansion_zeroelim(bxcalen, bxca, bdx, bxxca);
    const bycalen = scale_expansion_zeroelim(4, ca, bdy, byca);
    const byycalen = scale_expansion_zeroelim(bycalen, byca, bdy, byyca);
    const blen = fast_expansion_sum_zeroelim(bxxcalen, bxxca, byycalen, byyca, bdet);

    adxbdy1 = adx * bdy;
    c = splitter * adx;
    ahi = c - (c - adx);
    alo = adx - ahi;
    c = splitter * bdy;
    bhi = c - (c - bdy);
    blo = bdy - bhi;
    adxbdy0 = alo * blo - (adxbdy1 - ahi * bhi - alo * bhi - ahi * blo);
    bdxady1 = bdx * ady;
    c = splitter * bdx;
    ahi = c - (c - bdx);
    alo = bdx - ahi;
    c = splitter * ady;
    bhi = c - (c - ady);
    blo = ady - bhi;
    bdxady0 = alo * blo - (bdxady1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = adxbdy0 - bdxady0;
    bvirt = adxbdy0 - _i;
    ab[0] = adxbdy0 - (_i + bvirt) + (bvirt - bdxady0);
    _j = adxbdy1 + _i;
    bvirt = _j - adxbdy1;
    _0 = adxbdy1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - bdxady1;
    bvirt = _0 - _i;
    ab[1] = _0 - (_i + bvirt) + (bvirt - bdxady1);
    ab3 = _j + _i;
    bvirt = ab3 - _j;
    ab[2] = _j - (ab3 - bvirt) + (_i - bvirt);
    ab[3] = ab3;
    const cxablen = scale_expansion_zeroelim(4, ab, cdx, cxab);
    const cxxablen = scale_expansion_zeroelim(cxablen, cxab, cdx, cxxab);
    const cyablen = scale_expansion_zeroelim(4, ab, cdy, cyab);
    const cyyablen = scale_expansion_zeroelim(cyablen, cyab, cdy, cyyab);
    const clen = fast_expansion_sum_zeroelim(cxxablen, cxxab, cyyablen, cyyab, cdet);

    const ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, abdet);
    finlength = fast_expansion_sum_zeroelim(ablen, abdet, clen, cdet, fin1);

    let det = estimate(finlength, fin1);
    let errbound = iccerrboundB * permanent;
    if (det >= errbound || -det >= errbound) {
        return det;
    }

    bvirt = ax - adx;
    adxtail = ax - (adx + bvirt) + (bvirt - dx);
    bvirt = ay - ady;
    adytail = ay - (ady + bvirt) + (bvirt - dy);
    bvirt = bx - bdx;
    bdxtail = bx - (bdx + bvirt) + (bvirt - dx);
    bvirt = by - bdy;
    bdytail = by - (bdy + bvirt) + (bvirt - dy);
    bvirt = cx - cdx;
    cdxtail = cx - (cdx + bvirt) + (bvirt - dx);
    bvirt = cy - cdy;
    cdytail = cy - (cdy + bvirt) + (bvirt - dy);
    if (adxtail === 0 && bdxtail === 0 && cdxtail === 0 && adytail === 0 && bdytail === 0 && cdytail === 0) {
        return det;
    }

    errbound = iccerrboundC * permanent + resulterrbound * Math.abs(det);
    det += ((adx * adx + ady * ady) * ((bdx * cdytail + cdy * bdxtail) - (bdy * cdxtail + cdx * bdytail)) +
        2 * (adx * adxtail + ady * adytail) * (bdx * cdy - bdy * cdx)) +
        ((bdx * bdx + bdy * bdy) * ((cdx * adytail + ady * cdxtail) - (cdy * adxtail + adx * cdytail)) +
        2 * (bdx * bdxtail + bdy * bdytail) * (cdx * ady - cdy * adx)) +
        ((cdx * cdx + cdy * cdy) * ((adx * bdytail + bdy * adxtail) - (ady * bdxtail + bdx * adytail)) +
        2 * (cdx * cdxtail + cdy * cdytail) * (adx * bdy - ady * bdx));

    if (det >= errbound || -det >= errbound) {
        return det;
    }

    finnow = fin1;
    finother = fin2;

    if (bdxtail !== 0 || bdytail !== 0 || cdxtail !== 0 || cdytail !== 0) {
        adxadx1 = adx * adx;
        c = splitter * adx;
        ahi = c - (c - adx);
        alo = adx - ahi;
        adxadx0 = alo * alo - (adxadx1 - ahi * ahi - (ahi + ahi) * alo);
        adyady1 = ady * ady;
        c = splitter * ady;
        ahi = c - (c - ady);
        alo = ady - ahi;
        adyady0 = alo * alo - (adyady1 - ahi * ahi - (ahi + ahi) * alo);
        _i = adxadx0 + adyady0;
        bvirt = _i - adxadx0;
        aa[0] = adxadx0 - (_i - bvirt) + (adyady0 - bvirt);
        _j = adxadx1 + _i;
        bvirt = _j - adxadx1;
        _0 = adxadx1 - (_j - bvirt) + (_i - bvirt);
        _i = _0 + adyady1;
        bvirt = _i - _0;
        aa[1] = _0 - (_i - bvirt) + (adyady1 - bvirt);
        aa3 = _j + _i;
        bvirt = aa3 - _j;
        aa[2] = _j - (aa3 - bvirt) + (_i - bvirt);
        aa[3] = aa3;
    }
    if (cdxtail !== 0 || cdytail !== 0 || adxtail !== 0 || adytail !== 0) {
        bdxbdx1 = bdx * bdx;
        c = splitter * bdx;
        ahi = c - (c - bdx);
        alo = bdx - ahi;
        bdxbdx0 = alo * alo - (bdxbdx1 - ahi * ahi - (ahi + ahi) * alo);
        bdybdy1 = bdy * bdy;
        c = splitter * bdy;
        ahi = c - (c - bdy);
        alo = bdy - ahi;
        bdybdy0 = alo * alo - (bdybdy1 - ahi * ahi - (ahi + ahi) * alo);
        _i = bdxbdx0 + bdybdy0;
        bvirt = _i - bdxbdx0;
        bb[0] = bdxbdx0 - (_i - bvirt) + (bdybdy0 - bvirt);
        _j = bdxbdx1 + _i;
        bvirt = _j - bdxbdx1;
        _0 = bdxbdx1 - (_j - bvirt) + (_i - bvirt);
        _i = _0 + bdybdy1;
        bvirt = _i - _0;
        bb[1] = _0 - (_i - bvirt) + (bdybdy1 - bvirt);
        bb3 = _j + _i;
        bvirt = bb3 - _j;
        bb[2] = _j - (bb3 - bvirt) + (_i - bvirt);
        bb[3] = bb3;
    }
    if (adxtail !== 0 || adytail !== 0 || bdxtail !== 0 || bdytail !== 0) {
        cdxcdx1 = cdx * cdx;
        c = splitter * cdx;
        ahi = c - (c - cdx);
        alo = cdx - ahi;
        cdxcdx0 = alo * alo - (cdxcdx1 - ahi * ahi - (ahi + ahi) * alo);
        cdycdy1 = cdy * cdy;
        c = splitter * cdy;
        ahi = c - (c - cdy);
        alo = cdy - ahi;
        cdycdy0 = alo * alo - (cdycdy1 - ahi * ahi - (ahi + ahi) * alo);
        _i = cdxcdx0 + cdycdy0;
        bvirt = _i - cdxcdx0;
        cc[0] = cdxcdx0 - (_i - bvirt) + (cdycdy0 - bvirt);
        _j = cdxcdx1 + _i;
        bvirt = _j - cdxcdx1;
        _0 = cdxcdx1 - (_j - bvirt) + (_i - bvirt);
        _i = _0 + cdycdy1;
        bvirt = _i - _0;
        cc[1] = _0 - (_i - bvirt) + (cdycdy1 - bvirt);
        cc3 = _j + _i;
        bvirt = cc3 - _j;
        cc[2] = _j - (cc3 - bvirt) + (_i - bvirt);
        cc[3] = cc3;
    }

    if (adxtail !== 0) {
        axtbclen = scale_expansion_zeroelim(4, bc, adxtail, axtbc);
        temp16alen = scale_expansion_zeroelim(axtbclen, axtbc, 2 * adx, temp16a);

        axtcclen = scale_expansion_zeroelim(4, cc, adxtail, axtcc);
        temp16blen = scale_expansion_zeroelim(axtcclen, axtcc, bdy, temp16b);

        axtbblen = scale_expansion_zeroelim(4, bb, adxtail, axtbb);
        temp16clen = scale_expansion_zeroelim(axtbblen, axtbb, -cdy, temp16c);

        temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32a);
        temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, temp48);
        finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
        finswap = finnow; finnow = finother; finother = finswap;
    }
    if (adytail !== 0) {
        aytbclen = scale_expansion_zeroelim(4, bc, adytail, aytbc);
        temp16alen = scale_expansion_zeroelim(aytbclen, aytbc, 2 * ady, temp16a);

        aytbblen = scale_expansion_zeroelim(4, bb, adytail, aytbb);
        temp16blen = scale_expansion_zeroelim(aytbblen, aytbb, cdx, temp16b);

        aytcclen = scale_expansion_zeroelim(4, cc, adytail, aytcc);
        temp16clen = scale_expansion_zeroelim(aytcclen, aytcc, -bdx, temp16c);

        temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32a);
        temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, temp48);
        finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
        finswap = finnow; finnow = finother; finother = finswap;
    }
    if (bdxtail !== 0) {
        bxtcalen = scale_expansion_zeroelim(4, ca, bdxtail, bxtca);
        temp16alen = scale_expansion_zeroelim(bxtcalen, bxtca, 2 * bdx, temp16a);

        bxtaalen = scale_expansion_zeroelim(4, aa, bdxtail, bxtaa);
        temp16blen = scale_expansion_zeroelim(bxtaalen, bxtaa, cdy, temp16b);

        bxtcclen = scale_expansion_zeroelim(4, cc, bdxtail, bxtcc);
        temp16clen = scale_expansion_zeroelim(bxtcclen, bxtcc, -ady, temp16c);

        temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32a);
        temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, temp48);
        finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
        finswap = finnow; finnow = finother; finother = finswap;
    }
    if (bdytail !== 0) {
        bytcalen = scale_expansion_zeroelim(4, ca, bdytail, bytca);
        temp16alen = scale_expansion_zeroelim(bytcalen, bytca, 2 * bdy, temp16a);

        bytcclen = scale_expansion_zeroelim(4, cc, bdytail, bytcc);
        temp16blen = scale_expansion_zeroelim(bytcclen, bytcc, adx, temp16b);

        bytaalen = scale_expansion_zeroelim(4, aa, bdytail, bytaa);
        temp16clen = scale_expansion_zeroelim(bytaalen, bytaa, -cdx, temp16c);

        temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32a);
        temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, temp48);
        finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
        finswap = finnow; finnow = finother; finother = finswap;
    }
    if (cdxtail !== 0) {
        cxtablen = scale_expansion_zeroelim(4, ab, cdxtail, cxtab);
        temp16alen = scale_expansion_zeroelim(cxtablen, cxtab, 2 * cdx, temp16a);

        cxtbblen = scale_expansion_zeroelim(4, bb, cdxtail, cxtbb);
        temp16blen = scale_expansion_zeroelim(cxtbblen, cxtbb, ady, temp16b);

        cxtaalen = scale_expansion_zeroelim(4, aa, cdxtail, cxtaa);
        temp16clen = scale_expansion_zeroelim(cxtaalen, cxtaa, -bdy, temp16c);

        temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32a);
        temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, temp48);
        finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
        finswap = finnow; finnow = finother; finother = finswap;
    }
    if (cdytail !== 0) {
        cytablen = scale_expansion_zeroelim(4, ab, cdytail, cytab);
        temp16alen = scale_expansion_zeroelim(cytablen, cytab, 2 * cdy, temp16a);

        cytaalen = scale_expansion_zeroelim(4, aa, cdytail, cytaa);
        temp16blen = scale_expansion_zeroelim(cytaalen, cytaa, bdx, temp16b);

        cytbblen = scale_expansion_zeroelim(4, bb, cdytail, cytbb);
        temp16clen = scale_expansion_zeroelim(cytbblen, cytbb, -adx, temp16c);

        temp32alen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32a);
        temp48len = fast_expansion_sum_zeroelim(temp16clen, temp16c, temp32alen, temp32a, temp48);
        finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
        finswap = finnow; finnow = finother; finother = finswap;
    }

    if (adxtail !== 0 || adytail !== 0) {
        if (bdxtail !== 0 || bdytail !== 0 || cdxtail !== 0 || cdytail !== 0) {
            ti1 = bdxtail * cdy;
            c = splitter * bdxtail;
            ahi = c - (c - bdxtail);
            alo = bdxtail - ahi;
            c = splitter * cdy;
            bhi = c - (c - cdy);
            blo = cdy - bhi;
            ti0 = alo * blo - (ti1 - ahi * bhi - alo * bhi - ahi * blo);
            tj1 = bdx * cdytail;
            c = splitter * bdx;
            ahi = c - (c - bdx);
            alo = bdx - ahi;
            c = splitter * cdytail;
            bhi = c - (c - cdytail);
            blo = cdytail - bhi;
            tj0 = alo * blo - (tj1 - ahi * bhi - alo * bhi - ahi * blo);
            _i = ti0 + tj0;
            bvirt = _i - ti0;
            u[0] = ti0 - (_i - bvirt) + (tj0 - bvirt);
            _j = ti1 + _i;
            bvirt = _j - ti1;
            _0 = ti1 - (_j - bvirt) + (_i - bvirt);
            _i = _0 + tj1;
            bvirt = _i - _0;
            u[1] = _0 - (_i - bvirt) + (tj1 - bvirt);
            u3 = _j + _i;
            bvirt = u3 - _j;
            u[2] = _j - (u3 - bvirt) + (_i - bvirt);
            u[3] = u3;
            negate = -bdy;
            ti1 = cdxtail * negate;
            c = splitter * cdxtail;
            ahi = c - (c - cdxtail);
            alo = cdxtail - ahi;
            c = splitter * negate;
            bhi = c - (c - negate);
            blo = negate - bhi;
            ti0 = alo * blo - (ti1 - ahi * bhi - alo * bhi - ahi * blo);
            negate = -bdytail;
            tj1 = cdx * negate;
            c = splitter * cdx;
            ahi = c - (c - cdx);
            alo = cdx - ahi;
            c = splitter * negate;
            bhi = c - (c - negate);
            blo = negate - bhi;
            tj0 = alo * blo - (tj1 - ahi * bhi - alo * bhi - ahi * blo);
            _i = ti0 + tj0;
            bvirt = _i - ti0;
            v[0] = ti0 - (_i - bvirt) + (tj0 - bvirt);
            _j = ti1 + _i;
            bvirt = _j - ti1;
            _0 = ti1 - (_j - bvirt) + (_i - bvirt);
            _i = _0 + tj1;
            bvirt = _i - _0;
            v[1] = _0 - (_i - bvirt) + (tj1 - bvirt);
            v3 = _j + _i;
            bvirt = v3 - _j;
            v[2] = _j - (v3 - bvirt) + (_i - bvirt);
            v[3] = v3;
            bctlen = fast_expansion_sum_zeroelim(4, u, 4, v, bct);

            ti1 = bdxtail * cdytail;
            c = splitter * bdxtail;
            ahi = c - (c - bdxtail);
            alo = bdxtail - ahi;
            c = splitter * cdytail;
            bhi = c - (c - cdytail);
            blo = cdytail - bhi;
            ti0 = alo * blo - (ti1 - ahi * bhi - alo * bhi - ahi * blo);
            tj1 = cdxtail * bdytail;
            c = splitter * cdxtail;
            ahi = c - (c - cdxtail);
            alo = cdxtail - ahi;
            c = splitter * bdytail;
            bhi = c - (c - bdytail);
            blo = bdytail - bhi;
            tj0 = alo * blo - (tj1 - ahi * bhi - alo * bhi - ahi * blo);
            _i = ti0 - tj0;
            bvirt = ti0 - _i;
            bctt[0] = ti0 - (_i + bvirt) + (bvirt - tj0);
            _j = ti1 + _i;
            bvirt = _j - ti1;
            _0 = ti1 - (_j - bvirt) + (_i - bvirt);
            _i = _0 - tj1;
            bvirt = _0 - _i;
            bctt[1] = _0 - (_i + bvirt) + (bvirt - tj1);
            bctt3 = _j + _i;
            bvirt = bctt3 - _j;
            bctt[2] = _j - (bctt3 - bvirt) + (_i - bvirt);
            bctt[3] = bctt3;
            bcttlen = 4;
        } else {
            bct[0] = 0;
            bctlen = 1;
            bctt[0] = 0;
            bcttlen = 1;
        }

        if (adxtail !== 0) {
            temp16alen = scale_expansion_zeroelim(axtbclen, axtbc, adxtail, temp16a);
            axtbctlen = scale_expansion_zeroelim(bctlen, bct, adxtail, axtbct);
            temp32alen = scale_expansion_zeroelim(axtbctlen, axtbct, 2 * adx, temp32a);
            temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, temp48);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
            finswap = finnow; finnow = finother; finother = finswap;

            if (bdytail !== 0) {
                temp8len = scale_expansion_zeroelim(4, cc, adxtail, temp8);
                temp16alen = scale_expansion_zeroelim(temp8len, temp8, bdytail, temp16a);
                finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother);
                finswap = finnow; finnow = finother; finother = finswap;
            }
            if (cdytail !== 0) {
                temp8len = scale_expansion_zeroelim(4, bb, -adxtail, temp8);
                temp16alen = scale_expansion_zeroelim(temp8len, temp8, cdytail, temp16a);
                finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother);
                finswap = finnow; finnow = finother; finother = finswap;
            }

            temp32alen = scale_expansion_zeroelim(axtbctlen, axtbct, adxtail, temp32a);
            axtbcttlen = scale_expansion_zeroelim(bcttlen, bctt, adxtail, axtbctt);
            temp16alen = scale_expansion_zeroelim(axtbcttlen, axtbctt, 2 * adx, temp16a);
            temp16blen = scale_expansion_zeroelim(axtbcttlen, axtbctt, adxtail, temp16b);
            temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32b);
            temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother);
            finswap = finnow; finnow = finother; finother = finswap;
        }

        if (adytail !== 0) {
            temp16alen = scale_expansion_zeroelim(aytbclen, aytbc, adytail, temp16a);
            aytbctlen = scale_expansion_zeroelim(bctlen, bct, adytail, aytbct);
            temp32alen = scale_expansion_zeroelim(aytbctlen, aytbct, 2 * ady, temp32a);
            temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, temp48);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
            finswap = finnow; finnow = finother; finother = finswap;

            temp32alen = scale_expansion_zeroelim(aytbctlen, aytbct, adytail, temp32a);
            aytbcttlen = scale_expansion_zeroelim(bcttlen, bctt, adytail, aytbctt);
            temp16alen = scale_expansion_zeroelim(aytbcttlen, aytbctt, 2 * ady, temp16a);
            temp16blen = scale_expansion_zeroelim(aytbcttlen, aytbctt, adytail, temp16b);
            temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32b);
            temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother);
            finswap = finnow; finnow = finother; finother = finswap;
        }
    }
    if (bdxtail !== 0 || bdytail !== 0) {
        if (cdxtail !== 0 || cdytail !== 0 || adxtail !== 0 || adytail !== 0) {
            ti1 = cdxtail * ady;
            c = splitter * cdxtail;
            ahi = c - (c - cdxtail);
            alo = cdxtail - ahi;
            c = splitter * ady;
            bhi = c - (c - ady);
            blo = ady - bhi;
            ti0 = alo * blo - (ti1 - ahi * bhi - alo * bhi - ahi * blo);
            tj1 = cdx * adytail;
            c = splitter * cdx;
            ahi = c - (c - cdx);
            alo = cdx - ahi;
            c = splitter * adytail;
            bhi = c - (c - adytail);
            blo = adytail - bhi;
            tj0 = alo * blo - (tj1 - ahi * bhi - alo * bhi - ahi * blo);
            _i = ti0 + tj0;
            bvirt = _i - ti0;
            u[0] = ti0 - (_i - bvirt) + (tj0 - bvirt);
            _j = ti1 + _i;
            bvirt = _j - ti1;
            _0 = ti1 - (_j - bvirt) + (_i - bvirt);
            _i = _0 + tj1;
            bvirt = _i - _0;
            u[1] = _0 - (_i - bvirt) + (tj1 - bvirt);
            u3 = _j + _i;
            bvirt = u3 - _j;
            u[2] = _j - (u3 - bvirt) + (_i - bvirt);
            u[3] = u3;
            negate = -cdy;
            ti1 = adxtail * negate;
            c = splitter * adxtail;
            ahi = c - (c - adxtail);
            alo = adxtail - ahi;
            c = splitter * negate;
            bhi = c - (c - negate);
            blo = negate - bhi;
            ti0 = alo * blo - (ti1 - ahi * bhi - alo * bhi - ahi * blo);
            negate = -cdytail;
            tj1 = adx * negate;
            c = splitter * adx;
            ahi = c - (c - adx);
            alo = adx - ahi;
            c = splitter * negate;
            bhi = c - (c - negate);
            blo = negate - bhi;
            tj0 = alo * blo - (tj1 - ahi * bhi - alo * bhi - ahi * blo);
            _i = ti0 + tj0;
            bvirt = _i - ti0;
            v[0] = ti0 - (_i - bvirt) + (tj0 - bvirt);
            _j = ti1 + _i;
            bvirt = _j - ti1;
            _0 = ti1 - (_j - bvirt) + (_i - bvirt);
            _i = _0 + tj1;
            bvirt = _i - _0;
            v[1] = _0 - (_i - bvirt) + (tj1 - bvirt);
            v3 = _j + _i;
            bvirt = v3 - _j;
            v[2] = _j - (v3 - bvirt) + (_i - bvirt);
            v[3] = v3;
            catlen = fast_expansion_sum_zeroelim(4, u, 4, v, cat);

            ti1 = cdxtail * adytail;
            c = splitter * cdxtail;
            ahi = c - (c - cdxtail);
            alo = cdxtail - ahi;
            c = splitter * adytail;
            bhi = c - (c - adytail);
            blo = adytail - bhi;
            ti0 = alo * blo - (ti1 - ahi * bhi - alo * bhi - ahi * blo);
            tj1 = adxtail * cdytail;
            c = splitter * adxtail;
            ahi = c - (c - adxtail);
            alo = adxtail - ahi;
            c = splitter * cdytail;
            bhi = c - (c - cdytail);
            blo = cdytail - bhi;
            tj0 = alo * blo - (tj1 - ahi * bhi - alo * bhi - ahi * blo);
            _i = ti0 - tj0;
            bvirt = ti0 - _i;
            catt[0] = ti0 - (_i + bvirt) + (bvirt - tj0);
            _j = ti1 + _i;
            bvirt = _j - ti1;
            _0 = ti1 - (_j - bvirt) + (_i - bvirt);
            _i = _0 - tj1;
            bvirt = _0 - _i;
            catt[1] = _0 - (_i + bvirt) + (bvirt - tj1);
            catt3 = _j + _i;
            bvirt = catt3 - _j;
            catt[2] = _j - (catt3 - bvirt) + (_i - bvirt);
            catt[3] = catt3;
            cattlen = 4;
        } else {
            cat[0] = 0;
            catlen = 1;
            catt[0] = 0;
            cattlen = 1;
        }

        if (bdxtail !== 0) {
            temp16alen = scale_expansion_zeroelim(bxtcalen, bxtca, bdxtail, temp16a);
            bxtcatlen = scale_expansion_zeroelim(catlen, cat, bdxtail, bxtcat);
            temp32alen = scale_expansion_zeroelim(bxtcatlen, bxtcat, 2 * bdx, temp32a);
            temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, temp48);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
            finswap = finnow; finnow = finother; finother = finswap;
            if (cdytail !== 0) {
                temp8len = scale_expansion_zeroelim(4, aa, bdxtail, temp8);
                temp16alen = scale_expansion_zeroelim(temp8len, temp8, cdytail, temp16a);
                finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother);
                finswap = finnow; finnow = finother; finother = finswap;
            }
            if (adytail !== 0) {
                temp8len = scale_expansion_zeroelim(4, cc, -bdxtail, temp8);
                temp16alen = scale_expansion_zeroelim(temp8len, temp8, adytail, temp16a);
                finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother);
                finswap = finnow; finnow = finother; finother = finswap;
            }

            temp32alen = scale_expansion_zeroelim(bxtcatlen, bxtcat, bdxtail, temp32a);
            bxtcattlen = scale_expansion_zeroelim(cattlen, catt, bdxtail, bxtcatt);
            temp16alen = scale_expansion_zeroelim(bxtcattlen, bxtcatt, 2 * bdx, temp16a);
            temp16blen = scale_expansion_zeroelim(bxtcattlen, bxtcatt, bdxtail, temp16b);
            temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32b);
            temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother);
            finswap = finnow; finnow = finother; finother = finswap;
        }
        if (bdytail !== 0) {
            temp16alen = scale_expansion_zeroelim(bytcalen, bytca, bdytail, temp16a);
            bytcatlen = scale_expansion_zeroelim(catlen, cat, bdytail, bytcat);
            temp32alen = scale_expansion_zeroelim(bytcatlen, bytcat, 2 * bdy, temp32a);
            temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, temp48);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
            finswap = finnow; finnow = finother; finother = finswap;

            temp32alen = scale_expansion_zeroelim(bytcatlen, bytcat, bdytail, temp32a);
            bytcattlen = scale_expansion_zeroelim(cattlen, catt, bdytail, bytcatt);
            temp16alen = scale_expansion_zeroelim(bytcattlen, bytcatt, 2 * bdy, temp16a);
            temp16blen = scale_expansion_zeroelim(bytcattlen, bytcatt, bdytail, temp16b);
            temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32b);
            temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother);
            finswap = finnow; finnow = finother; finother = finswap;
        }
    }
    if (cdxtail !== 0 || cdytail !== 0) {
        if (adxtail !== 0 || adytail !== 0 || bdxtail !== 0 || bdytail !== 0) {
            ti1 = adxtail * bdy;
            c = splitter * adxtail;
            ahi = c - (c - adxtail);
            alo = adxtail - ahi;
            c = splitter * bdy;
            bhi = c - (c - bdy);
            blo = bdy - bhi;
            ti0 = alo * blo - (ti1 - ahi * bhi - alo * bhi - ahi * blo);
            tj1 = adx * bdytail;
            c = splitter * adx;
            ahi = c - (c - adx);
            alo = adx - ahi;
            c = splitter * bdytail;
            bhi = c - (c - bdytail);
            blo = bdytail - bhi;
            tj0 = alo * blo - (tj1 - ahi * bhi - alo * bhi - ahi * blo);
            _i = ti0 + tj0;
            bvirt = _i - ti0;
            u[0] = ti0 - (_i - bvirt) + (tj0 - bvirt);
            _j = ti1 + _i;
            bvirt = _j - ti1;
            _0 = ti1 - (_j - bvirt) + (_i - bvirt);
            _i = _0 + tj1;
            bvirt = _i - _0;
            u[1] = _0 - (_i - bvirt) + (tj1 - bvirt);
            u3 = _j + _i;
            bvirt = u3 - _j;
            u[2] = _j - (u3 - bvirt) + (_i - bvirt);
            u[3] = u3;
            negate = -ady;
            ti1 = bdxtail * negate;
            c = splitter * bdxtail;
            ahi = c - (c - bdxtail);
            alo = bdxtail - ahi;
            c = splitter * negate;
            bhi = c - (c - negate);
            blo = negate - bhi;
            ti0 = alo * blo - (ti1 - ahi * bhi - alo * bhi - ahi * blo);
            negate = -adytail;
            tj1 = bdx * negate;
            c = splitter * bdx;
            ahi = c - (c - bdx);
            alo = bdx - ahi;
            c = splitter * negate;
            bhi = c - (c - negate);
            blo = negate - bhi;
            tj0 = alo * blo - (tj1 - ahi * bhi - alo * bhi - ahi * blo);
            _i = ti0 + tj0;
            bvirt = _i - ti0;
            v[0] = ti0 - (_i - bvirt) + (tj0 - bvirt);
            _j = ti1 + _i;
            bvirt = _j - ti1;
            _0 = ti1 - (_j - bvirt) + (_i - bvirt);
            _i = _0 + tj1;
            bvirt = _i - _0;
            v[1] = _0 - (_i - bvirt) + (tj1 - bvirt);
            v3 = _j + _i;
            bvirt = v3 - _j;
            v[2] = _j - (v3 - bvirt) + (_i - bvirt);
            v[3] = v3;
            abtlen = fast_expansion_sum_zeroelim(4, u, 4, v, abt);

            ti1 = adxtail * bdytail;
            c = splitter * adxtail;
            ahi = c - (c - adxtail);
            alo = adxtail - ahi;
            c = splitter * bdytail;
            bhi = c - (c - bdytail);
            blo = bdytail - bhi;
            ti0 = alo * blo - (ti1 - ahi * bhi - alo * bhi - ahi * blo);
            tj1 = bdxtail * adytail;
            c = splitter * bdxtail;
            ahi = c - (c - bdxtail);
            alo = bdxtail - ahi;
            c = splitter * adytail;
            bhi = c - (c - adytail);
            blo = adytail - bhi;
            tj0 = alo * blo - (tj1 - ahi * bhi - alo * bhi - ahi * blo);
            _i = ti0 - tj0;
            bvirt = ti0 - _i;
            abtt[0] = ti0 - (_i + bvirt) + (bvirt - tj0);
            _j = ti1 + _i;
            bvirt = _j - ti1;
            _0 = ti1 - (_j - bvirt) + (_i - bvirt);
            _i = _0 - tj1;
            bvirt = _0 - _i;
            abtt[1] = _0 - (_i + bvirt) + (bvirt - tj1);
            abtt3 = _j + _i;
            bvirt = abtt3 - _j;
            abtt[2] = _j - (abtt3 - bvirt) + (_i - bvirt);
            abtt[3] = abtt3;
            abttlen = 4;
        } else {
            abt[0] = 0;
            abtlen = 1;
            abtt[0] = 0;
            abttlen = 1;
        }

        if (cdxtail !== 0) {
            temp16alen = scale_expansion_zeroelim(cxtablen, cxtab, cdxtail, temp16a);
            cxtabtlen = scale_expansion_zeroelim(abtlen, abt, cdxtail, cxtabt);
            temp32alen = scale_expansion_zeroelim(cxtabtlen, cxtabt, 2 * cdx, temp32a);
            temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, temp48);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
            finswap = finnow; finnow = finother; finother = finswap;
            if (adytail !== 0) {
                temp8len = scale_expansion_zeroelim(4, bb, cdxtail, temp8);
                temp16alen = scale_expansion_zeroelim(temp8len, temp8, adytail, temp16a);
                finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother);
                finswap = finnow; finnow = finother; finother = finswap;
            }
            if (bdytail !== 0) {
                temp8len = scale_expansion_zeroelim(4, aa, -cdxtail, temp8);
                temp16alen = scale_expansion_zeroelim(temp8len, temp8, bdytail, temp16a);
                finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp16alen, temp16a, finother);
                finswap = finnow; finnow = finother; finother = finswap;
            }

            temp32alen = scale_expansion_zeroelim(cxtabtlen, cxtabt, cdxtail, temp32a);
            cxtabttlen = scale_expansion_zeroelim(abttlen, abtt, cdxtail, cxtabtt);
            temp16alen = scale_expansion_zeroelim(cxtabttlen, cxtabtt, 2 * cdx, temp16a);
            temp16blen = scale_expansion_zeroelim(cxtabttlen, cxtabtt, cdxtail, temp16b);
            temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32b);
            temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother);
            finswap = finnow; finnow = finother; finother = finswap;
        }
        if (cdytail !== 0) {
            temp16alen = scale_expansion_zeroelim(cytablen, cytab, cdytail, temp16a);
            cytabtlen = scale_expansion_zeroelim(abtlen, abt, cdytail, cytabt);
            temp32alen = scale_expansion_zeroelim(cytabtlen, cytabt, 2 * cdy, temp32a);
            temp48len = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp32alen, temp32a, temp48);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp48len, temp48, finother);
            finswap = finnow; finnow = finother; finother = finswap;

            temp32alen = scale_expansion_zeroelim(cytabtlen, cytabt, cdytail, temp32a);
            cytabttlen = scale_expansion_zeroelim(abttlen, abtt, cdytail, cytabtt);
            temp16alen = scale_expansion_zeroelim(cytabttlen, cytabtt, 2 * cdy, temp16a);
            temp16blen = scale_expansion_zeroelim(cytabttlen, cytabtt, cdytail, temp16b);
            temp32blen = fast_expansion_sum_zeroelim(temp16alen, temp16a, temp16blen, temp16b, temp32b);
            temp64len = fast_expansion_sum_zeroelim(temp32alen, temp32a, temp32blen, temp32b, temp64);
            finlength = fast_expansion_sum_zeroelim(finlength, finnow, temp64len, temp64, finother);
            finswap = finnow; finnow = finother; finother = finswap;
        }
    }

    return finnow[finlength - 1];
}

export function incircle(ax, ay, bx, by, cx, cy, dx, dy) {
    const adx = ax - dx;
    const bdx = bx - dx;
    const cdx = cx - dx;
    const ady = ay - dy;
    const bdy = by - dy;
    const cdy = cy - dy;

    const bdxcdy = bdx * cdy;
    const cdxbdy = cdx * bdy;
    const alift = adx * adx + ady * ady;

    const cdxady = cdx * ady;
    const adxcdy = adx * cdy;
    const blift = bdx * bdx + bdy * bdy;

    const adxbdy = adx * bdy;
    const bdxady = bdx * ady;
    const clift = cdx * cdx + cdy * cdy;

    const det =
        alift * (bdxcdy - cdxbdy) +
        blift * (cdxady - adxcdy) +
        clift * (adxbdy - bdxady);

    const permanent =
        (Math.abs(bdxcdy) + Math.abs(cdxbdy)) * alift +
        (Math.abs(cdxady) + Math.abs(adxcdy)) * blift +
        (Math.abs(adxbdy) + Math.abs(bdxady)) * clift;

    const errbound = iccerrboundA * permanent;

    if (det > errbound || -det > errbound) {
        return det;
    }
    return incircleadapt(ax, ay, bx, by, cx, cy, dx, dy, permanent);
}

export function incirclefast(ax, ay, bx, by, cx, cy, dx, dy) {
    const adx = ax - dx;
    const ady = ay - dy;
    const bdx = bx - dx;
    const bdy = by - dy;
    const cdx = cx - dx;
    const cdy = cy - dy;

    const abdet = adx * bdy - bdx * ady;
    const bcdet = bdx * cdy - cdx * bdy;
    const cadet = cdx * ady - adx * cdy;
    const alift = adx * adx + ady * ady;
    const blift = bdx * bdx + bdy * bdy;
    const clift = cdx * cdx + cdy * cdy;

    return alift * bcdet + blift * cadet + clift * abdet;
}
