import {
    epsilon, splitter, resulterrbound, estimate, vec,
    fast_expansion_sum_zeroelim, scale_expansion_zeroelim
} from './util.js';

const isperrboundA = (16 + 224 * epsilon) * epsilon;
const isperrboundB = (5 + 72 * epsilon) * epsilon;
const isperrboundC = (71 + 1408 * epsilon) * epsilon * epsilon;

const ab = vec(4);
const bc = vec(4);
const cd = vec(4);
const de = vec(4);
const ea = vec(4);
const ac = vec(4);
const bd = vec(4);
const ce = vec(4);
const da = vec(4);
const eb = vec(4);
const temp8a = vec(8);
const temp8b = vec(8);
const temp16 = vec(16);
const abc = vec(24);
const bcd = vec(24);
const cde = vec(24);
const dea = vec(24);
const eab = vec(24);
const abd = vec(24);
const bce = vec(24);
const cda = vec(24);
const deb = vec(24);
const eac = vec(24);
const temp48a = vec(48);
const temp48b = vec(48);
const abcd = vec(96);
const bcde = vec(96);
const cdea = vec(96);
const deab = vec(96);
const eabc = vec(96);
const temp192 = vec(192);
const det384x = vec(384);
const det384y = vec(384);
const det384z = vec(384);
const detxy = vec(768);
const adet = vec(1152);
const bdet = vec(1152);
const cdet = vec(1152);
const ddet = vec(1152);
const edet = vec(1152);
const abdet = vec(2304);
const cddet = vec(2304);
const cdedet = vec(3456);
const deter = vec(5760);

function insphereexact(pa, pb, pc, pd, pe) {
    let axby1, bxcy1, cxdy1, dxey1, exay1;
    let bxay1, cxby1, dxcy1, exdy1, axey1;
    let axcy1, bxdy1, cxey1, dxay1, exby1;
    let cxay1, dxby1, excy1, axdy1, bxey1;
    let axby0, bxcy0, cxdy0, dxey0, exay0;
    let bxay0, cxby0, dxcy0, exdy0, axey0;
    let axcy0, bxdy0, cxey0, dxay0, exby0;
    let cxay0, dxby0, excy0, axdy0, bxey0;
    let temp8alen, temp8blen, temp16len;
    let temp48alen, temp48blen;
    let xlen, ylen, zlen;
    let xylen;
    let i;

    let bvirt, c, ahi, alo, bhi, blo, _i, _j, _0;

    axby1 = pa[0] * pb[1];
    c = splitter * pa[0];
    ahi = c - (c - pa[0]);
    alo = pa[0] - ahi;
    c = splitter * pb[1];
    bhi = c - (c - pb[1]);
    blo = pb[1] - bhi;
    axby0 = alo * blo - (axby1 - ahi * bhi - alo * bhi - ahi * blo);
    bxay1 = pb[0] * pa[1];
    c = splitter * pb[0];
    ahi = c - (c - pb[0]);
    alo = pb[0] - ahi;
    c = splitter * pa[1];
    bhi = c - (c - pa[1]);
    blo = pa[1] - bhi;
    bxay0 = alo * blo - (bxay1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = axby0 - bxay0;
    bvirt = axby0 - _i;
    ab[0] = axby0 - (_i + bvirt) + (bvirt - bxay0);
    _j = axby1 + _i;
    bvirt = _j - axby1;
    _0 = axby1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - bxay1;
    bvirt = _0 - _i;
    ab[1] = _0 - (_i + bvirt) + (bvirt - bxay1);
    ab[3] = _j + _i;
    bvirt = ab[3] - _j;
    ab[2] = _j - (ab[3] - bvirt) + (_i - bvirt);

    bxcy1 = pb[0] * pc[1];
    c = splitter * pb[0];
    ahi = c - (c - pb[0]);
    alo = pb[0] - ahi;
    c = splitter * pc[1];
    bhi = c - (c - pc[1]);
    blo = pc[1] - bhi;
    bxcy0 = alo * blo - (bxcy1 - ahi * bhi - alo * bhi - ahi * blo);
    cxby1 = pc[0] * pb[1];
    c = splitter * pc[0];
    ahi = c - (c - pc[0]);
    alo = pc[0] - ahi;
    c = splitter * pb[1];
    bhi = c - (c - pb[1]);
    blo = pb[1] - bhi;
    cxby0 = alo * blo - (cxby1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = bxcy0 - cxby0;
    bvirt = bxcy0 - _i;
    bc[0] = bxcy0 - (_i + bvirt) + (bvirt - cxby0);
    _j = bxcy1 + _i;
    bvirt = _j - bxcy1;
    _0 = bxcy1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - cxby1;
    bvirt = _0 - _i;
    bc[1] = _0 - (_i + bvirt) + (bvirt - cxby1);
    bc[3] = _j + _i;
    bvirt = bc[3] - _j;
    bc[2] = _j - (bc[3] - bvirt) + (_i - bvirt);

    cxdy1 = pc[0] * pd[1];
    c = splitter * pc[0];
    ahi = c - (c - pc[0]);
    alo = pc[0] - ahi;
    c = splitter * pd[1];
    bhi = c - (c - pd[1]);
    blo = pd[1] - bhi;
    cxdy0 = alo * blo - (cxdy1 - ahi * bhi - alo * bhi - ahi * blo);
    dxcy1 = pd[0] * pc[1];
    c = splitter * pd[0];
    ahi = c - (c - pd[0]);
    alo = pd[0] - ahi;
    c = splitter * pc[1];
    bhi = c - (c - pc[1]);
    blo = pc[1] - bhi;
    dxcy0 = alo * blo - (dxcy1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = cxdy0 - dxcy0;
    bvirt = cxdy0 - _i;
    cd[0] = cxdy0 - (_i + bvirt) + (bvirt - dxcy0);
    _j = cxdy1 + _i;
    bvirt = _j - cxdy1;
    _0 = cxdy1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - dxcy1;
    bvirt = _0 - _i;
    cd[1] = _0 - (_i + bvirt) + (bvirt - dxcy1);
    cd[3] = _j + _i;
    bvirt = cd[3] - _j;
    cd[2] = _j - (cd[3] - bvirt) + (_i - bvirt);

    dxey1 = pd[0] * pe[1];
    c = splitter * pd[0];
    ahi = c - (c - pd[0]);
    alo = pd[0] - ahi;
    c = splitter * pe[1];
    bhi = c - (c - pe[1]);
    blo = pe[1] - bhi;
    dxey0 = alo * blo - (dxey1 - ahi * bhi - alo * bhi - ahi * blo);
    exdy1 = pe[0] * pd[1];
    c = splitter * pe[0];
    ahi = c - (c - pe[0]);
    alo = pe[0] - ahi;
    c = splitter * pd[1];
    bhi = c - (c - pd[1]);
    blo = pd[1] - bhi;
    exdy0 = alo * blo - (exdy1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = dxey0 - exdy0;
    bvirt = dxey0 - _i;
    de[0] = dxey0 - (_i + bvirt) + (bvirt - exdy0);
    _j = dxey1 + _i;
    bvirt = _j - dxey1;
    _0 = dxey1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - exdy1;
    bvirt = _0 - _i;
    de[1] = _0 - (_i + bvirt) + (bvirt - exdy1);
    de[3] = _j + _i;
    bvirt = de[3] - _j;
    de[2] = _j - (de[3] - bvirt) + (_i - bvirt);

    exay1 = pe[0] * pa[1];
    c = splitter * pe[0];
    ahi = c - (c - pe[0]);
    alo = pe[0] - ahi;
    c = splitter * pa[1];
    bhi = c - (c - pa[1]);
    blo = pa[1] - bhi;
    exay0 = alo * blo - (exay1 - ahi * bhi - alo * bhi - ahi * blo);
    axey1 = pa[0] * pe[1];
    c = splitter * pa[0];
    ahi = c - (c - pa[0]);
    alo = pa[0] - ahi;
    c = splitter * pe[1];
    bhi = c - (c - pe[1]);
    blo = pe[1] - bhi;
    axey0 = alo * blo - (axey1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = exay0 - axey0;
    bvirt = exay0 - _i;
    ea[0] = exay0 - (_i + bvirt) + (bvirt - axey0);
    _j = exay1 + _i;
    bvirt = _j - exay1;
    _0 = exay1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - axey1;
    bvirt = _0 - _i;
    ea[1] = _0 - (_i + bvirt) + (bvirt - axey1);
    ea[3] = _j + _i;
    bvirt = ea[3] - _j;
    ea[2] = _j - (ea[3] - bvirt) + (_i - bvirt);

    axcy1 = pa[0] * pc[1];
    c = splitter * pa[0];
    ahi = c - (c - pa[0]);
    alo = pa[0] - ahi;
    c = splitter * pc[1];
    bhi = c - (c - pc[1]);
    blo = pc[1] - bhi;
    axcy0 = alo * blo - (axcy1 - ahi * bhi - alo * bhi - ahi * blo);
    cxay1 = pc[0] * pa[1];
    c = splitter * pc[0];
    ahi = c - (c - pc[0]);
    alo = pc[0] - ahi;
    c = splitter * pa[1];
    bhi = c - (c - pa[1]);
    blo = pa[1] - bhi;
    cxay0 = alo * blo - (cxay1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = axcy0 - cxay0;
    bvirt = axcy0 - _i;
    ac[0] = axcy0 - (_i + bvirt) + (bvirt - cxay0);
    _j = axcy1 + _i;
    bvirt = _j - axcy1;
    _0 = axcy1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - cxay1;
    bvirt = _0 - _i;
    ac[1] = _0 - (_i + bvirt) + (bvirt - cxay1);
    ac[3] = _j + _i;
    bvirt = ac[3] - _j;
    ac[2] = _j - (ac[3] - bvirt) + (_i - bvirt);

    bxdy1 = pb[0] * pd[1];
    c = splitter * pb[0];
    ahi = c - (c - pb[0]);
    alo = pb[0] - ahi;
    c = splitter * pd[1];
    bhi = c - (c - pd[1]);
    blo = pd[1] - bhi;
    bxdy0 = alo * blo - (bxdy1 - ahi * bhi - alo * bhi - ahi * blo);
    dxby1 = pd[0] * pb[1];
    c = splitter * pd[0];
    ahi = c - (c - pd[0]);
    alo = pd[0] - ahi;
    c = splitter * pb[1];
    bhi = c - (c - pb[1]);
    blo = pb[1] - bhi;
    dxby0 = alo * blo - (dxby1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = bxdy0 - dxby0;
    bvirt = bxdy0 - _i;
    bd[0] = bxdy0 - (_i + bvirt) + (bvirt - dxby0);
    _j = bxdy1 + _i;
    bvirt = _j - bxdy1;
    _0 = bxdy1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - dxby1;
    bvirt = _0 - _i;
    bd[1] = _0 - (_i + bvirt) + (bvirt - dxby1);
    bd[3] = _j + _i;
    bvirt = bd[3] - _j;
    bd[2] = _j - (bd[3] - bvirt) + (_i - bvirt);

    cxey1 = pc[0] * pe[1];
    c = splitter * pc[0];
    ahi = c - (c - pc[0]);
    alo = pc[0] - ahi;
    c = splitter * pe[1];
    bhi = c - (c - pe[1]);
    blo = pe[1] - bhi;
    cxey0 = alo * blo - (cxey1 - ahi * bhi - alo * bhi - ahi * blo);
    excy1 = pe[0] * pc[1];
    c = splitter * pe[0];
    ahi = c - (c - pe[0]);
    alo = pe[0] - ahi;
    c = splitter * pc[1];
    bhi = c - (c - pc[1]);
    blo = pc[1] - bhi;
    excy0 = alo * blo - (excy1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = cxey0 - excy0;
    bvirt = cxey0 - _i;
    ce[0] = cxey0 - (_i + bvirt) + (bvirt - excy0);
    _j = cxey1 + _i;
    bvirt = _j - cxey1;
    _0 = cxey1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - excy1;
    bvirt = _0 - _i;
    ce[1] = _0 - (_i + bvirt) + (bvirt - excy1);
    ce[3] = _j + _i;
    bvirt = ce[3] - _j;
    ce[2] = _j - (ce[3] - bvirt) + (_i - bvirt);

    dxay1 = pd[0] * pa[1];
    c = splitter * pd[0];
    ahi = c - (c - pd[0]);
    alo = pd[0] - ahi;
    c = splitter * pa[1];
    bhi = c - (c - pa[1]);
    blo = pa[1] - bhi;
    dxay0 = alo * blo - (dxay1 - ahi * bhi - alo * bhi - ahi * blo);
    axdy1 = pa[0] * pd[1];
    c = splitter * pa[0];
    ahi = c - (c - pa[0]);
    alo = pa[0] - ahi;
    c = splitter * pd[1];
    bhi = c - (c - pd[1]);
    blo = pd[1] - bhi;
    axdy0 = alo * blo - (axdy1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = dxay0 - axdy0;
    bvirt = dxay0 - _i;
    da[0] = dxay0 - (_i + bvirt) + (bvirt - axdy0);
    _j = dxay1 + _i;
    bvirt = _j - dxay1;
    _0 = dxay1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - axdy1;
    bvirt = _0 - _i;
    da[1] = _0 - (_i + bvirt) + (bvirt - axdy1);
    da[3] = _j + _i;
    bvirt = da[3] - _j;
    da[2] = _j - (da[3] - bvirt) + (_i - bvirt);

    exby1 = pe[0] * pb[1];
    c = splitter * pe[0];
    ahi = c - (c - pe[0]);
    alo = pe[0] - ahi;
    c = splitter * pb[1];
    bhi = c - (c - pb[1]);
    blo = pb[1] - bhi;
    exby0 = alo * blo - (exby1 - ahi * bhi - alo * bhi - ahi * blo);
    bxey1 = pb[0] * pe[1];
    c = splitter * pb[0];
    ahi = c - (c - pb[0]);
    alo = pb[0] - ahi;
    c = splitter * pe[1];
    bhi = c - (c - pe[1]);
    blo = pe[1] - bhi;
    bxey0 = alo * blo - (bxey1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = exby0 - bxey0;
    bvirt = exby0 - _i;
    eb[0] = exby0 - (_i + bvirt) + (bvirt - bxey0);
    _j = exby1 + _i;
    bvirt = _j - exby1;
    _0 = exby1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - bxey1;
    bvirt = _0 - _i;
    eb[1] = _0 - (_i + bvirt) + (bvirt - bxey1);
    eb[3] = _j + _i;
    bvirt = eb[3] - _j;
    eb[2] = _j - (eb[3] - bvirt) + (_i - bvirt);

    temp8alen = scale_expansion_zeroelim(4, bc, pa[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, ac, -pb[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, ab, pc[2], temp8a);
    const abclen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, abc);

    temp8alen = scale_expansion_zeroelim(4, cd, pb[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, bd, -pc[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, bc, pd[2], temp8a);
    const bcdlen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, bcd);

    temp8alen = scale_expansion_zeroelim(4, de, pc[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, ce, -pd[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, cd, pe[2], temp8a);
    let cdelen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, cde);

    temp8alen = scale_expansion_zeroelim(4, ea, pd[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, da, -pe[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, de, pa[2], temp8a);
    const dealen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, dea);

    temp8alen = scale_expansion_zeroelim(4, ab, pe[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, eb, -pa[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, ea, pb[2], temp8a);
    const eablen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, eab);

    temp8alen = scale_expansion_zeroelim(4, bd, pa[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, da, pb[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, ab, pd[2], temp8a);
    const abdlen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, abd);

    temp8alen = scale_expansion_zeroelim(4, ce, pb[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, eb, pc[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, bc, pe[2], temp8a);
    const bcelen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, bce);

    temp8alen = scale_expansion_zeroelim(4, da, pc[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, ac, pd[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, cd, pa[2], temp8a);
    const cdalen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, cda);

    temp8alen = scale_expansion_zeroelim(4, eb, pd[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, bd, pe[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, de, pb[2], temp8a);
    const deblen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, deb);

    temp8alen = scale_expansion_zeroelim(4, ac, pe[2], temp8a);
    temp8blen = scale_expansion_zeroelim(4, ce, pa[2], temp8b);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp8alen = scale_expansion_zeroelim(4, ea, pc[2], temp8a);
    const eaclen = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp16len, temp16, eac);

    temp48alen = fast_expansion_sum_zeroelim(cdelen, cde, bcelen, bce, temp48a);
    temp48blen = fast_expansion_sum_zeroelim(deblen, deb, bcdlen, bcd, temp48b);
    for (i = 0; i < temp48blen; i++) {
        temp48b[i] = -temp48b[i];
    }
    const bcdelen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, bcde);
    xlen = scale_expansion_zeroelim(bcdelen, bcde, pa[0], temp192);
    xlen = scale_expansion_zeroelim(xlen, temp192, pa[0], det384x);
    ylen = scale_expansion_zeroelim(bcdelen, bcde, pa[1], temp192);
    ylen = scale_expansion_zeroelim(ylen, temp192, pa[1], det384y);
    zlen = scale_expansion_zeroelim(bcdelen, bcde, pa[2], temp192);
    zlen = scale_expansion_zeroelim(zlen, temp192, pa[2], det384z);
    xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy);
    const alen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, adet);

    temp48alen = fast_expansion_sum_zeroelim(dealen, dea, cdalen, cda, temp48a);
    temp48blen = fast_expansion_sum_zeroelim(eaclen, eac, cdelen, cde, temp48b);
    for (i = 0; i < temp48blen; i++) {
        temp48b[i] = -temp48b[i];
    }
    const cdealen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, cdea);
    xlen = scale_expansion_zeroelim(cdealen, cdea, pb[0], temp192);
    xlen = scale_expansion_zeroelim(xlen, temp192, pb[0], det384x);
    ylen = scale_expansion_zeroelim(cdealen, cdea, pb[1], temp192);
    ylen = scale_expansion_zeroelim(ylen, temp192, pb[1], det384y);
    zlen = scale_expansion_zeroelim(cdealen, cdea, pb[2], temp192);
    zlen = scale_expansion_zeroelim(zlen, temp192, pb[2], det384z);
    xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy);
    const blen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, bdet);

    temp48alen = fast_expansion_sum_zeroelim(eablen, eab, deblen, deb, temp48a);
    temp48blen = fast_expansion_sum_zeroelim(abdlen, abd, dealen, dea, temp48b);
    for (i = 0; i < temp48blen; i++) {
        temp48b[i] = -temp48b[i];
    }
    const deablen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, deab);
    xlen = scale_expansion_zeroelim(deablen, deab, pc[0], temp192);
    xlen = scale_expansion_zeroelim(xlen, temp192, pc[0], det384x);
    ylen = scale_expansion_zeroelim(deablen, deab, pc[1], temp192);
    ylen = scale_expansion_zeroelim(ylen, temp192, pc[1], det384y);
    zlen = scale_expansion_zeroelim(deablen, deab, pc[2], temp192);
    zlen = scale_expansion_zeroelim(zlen, temp192, pc[2], det384z);
    xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy);
    const clen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, cdet);

    temp48alen = fast_expansion_sum_zeroelim(abclen, abc, eaclen, eac, temp48a);
    temp48blen = fast_expansion_sum_zeroelim(bcelen, bce, eablen, eab, temp48b);
    for (i = 0; i < temp48blen; i++) {
        temp48b[i] = -temp48b[i];
    }
    const eabclen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, eabc);
    xlen = scale_expansion_zeroelim(eabclen, eabc, pd[0], temp192);
    xlen = scale_expansion_zeroelim(xlen, temp192, pd[0], det384x);
    ylen = scale_expansion_zeroelim(eabclen, eabc, pd[1], temp192);
    ylen = scale_expansion_zeroelim(ylen, temp192, pd[1], det384y);
    zlen = scale_expansion_zeroelim(eabclen, eabc, pd[2], temp192);
    zlen = scale_expansion_zeroelim(zlen, temp192, pd[2], det384z);
    xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy);
    const dlen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, ddet);

    temp48alen = fast_expansion_sum_zeroelim(bcdlen, bcd, abdlen, abd, temp48a);
    temp48blen = fast_expansion_sum_zeroelim(cdalen, cda, abclen, abc, temp48b);
    for (i = 0; i < temp48blen; i++) {
        temp48b[i] = -temp48b[i];
    }
    const abcdlen = fast_expansion_sum_zeroelim(temp48alen, temp48a, temp48blen, temp48b, abcd);
    xlen = scale_expansion_zeroelim(abcdlen, abcd, pe[0], temp192);
    xlen = scale_expansion_zeroelim(xlen, temp192, pe[0], det384x);
    ylen = scale_expansion_zeroelim(abcdlen, abcd, pe[1], temp192);
    ylen = scale_expansion_zeroelim(ylen, temp192, pe[1], det384y);
    zlen = scale_expansion_zeroelim(abcdlen, abcd, pe[2], temp192);
    zlen = scale_expansion_zeroelim(zlen, temp192, pe[2], det384z);
    xylen = fast_expansion_sum_zeroelim(xlen, det384x, ylen, det384y, detxy);
    const elen = fast_expansion_sum_zeroelim(xylen, detxy, zlen, det384z, edet);

    const ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, abdet);
    const cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, cddet);
    cdelen = fast_expansion_sum_zeroelim(cdlen, cddet, elen, edet, cdedet);
    const deterlen = fast_expansion_sum_zeroelim(ablen, abdet, cdelen, cdedet, deter);

    return deter[deterlen - 1];
}

const temp8c = vec(8);
const temp24 = vec(24);
const temp48 = vec(48);
const xdet = vec(96);
const ydet = vec(96);
const zdet = vec(96);
const xydet = vec(192);
const fin1 = vec(1152);

function insphereadapt(ax, ay, az, bx, by, bz, cx, cy, cz, dx, dy, dz, ex, ey, ez, permanent) {
    let aexbey1, bexaey1, bexcey1, cexbey1;
    let cexdey1, dexcey1, dexaey1, aexdey1;
    let aexcey1, cexaey1, bexdey1, dexbey1;
    let aexbey0, bexaey0, bexcey0, cexbey0;
    let cexdey0, dexcey0, dexaey0, aexdey0;
    let aexcey0, cexaey0, bexdey0, dexbey0;
    let ab3, bc3, cd3, da3, ac3, bd3;
    let temp8alen, temp8blen, temp8clen, temp16len, temp24len, temp48len;
    let xlen, ylen, zlen, xylen;

    let aextail, bextail, cextail, dextail;
    let aeytail, beytail, ceytail, deytail;
    let aeztail, beztail, ceztail, deztail;

    let bvirt, c, ahi, alo, bhi, blo, _i, _j, _0;

    const aex = ax - ex;
    const bex = bx - ex;
    const cex = cx - ex;
    const dex = dx - ex;
    const aey = ay - ey;
    const bey = by - ey;
    const cey = cy - ey;
    const dey = dy - ey;
    const aez = az - ez;
    const bez = bz - ez;
    const cez = cz - ez;
    const dez = dz - ez;

    aexbey1 = aex * bey;
    c = splitter * aex;
    ahi = c - (c - aex);
    alo = aex - ahi;
    c = splitter * bey;
    bhi = c - (c - bey);
    blo = bey - bhi;
    aexbey0 = alo * blo - (aexbey1 - ahi * bhi - alo * bhi - ahi * blo);
    bexaey1 = bex * aey;
    c = splitter * bex;
    ahi = c - (c - bex);
    alo = bex - ahi;
    c = splitter * aey;
    bhi = c - (c - aey);
    blo = aey - bhi;
    bexaey0 = alo * blo - (bexaey1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = aexbey0 - bexaey0;
    bvirt = aexbey0 - _i;
    ab[0] = aexbey0 - (_i + bvirt) + (bvirt - bexaey0);
    _j = aexbey1 + _i;
    bvirt = _j - aexbey1;
    _0 = aexbey1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - bexaey1;
    bvirt = _0 - _i;
    ab[1] = _0 - (_i + bvirt) + (bvirt - bexaey1);
    ab3 = _j + _i;
    bvirt = ab3 - _j;
    ab[2] = _j - (ab3 - bvirt) + (_i - bvirt);
    ab[3] = ab3;

    bexcey1 = bex * cey;
    c = splitter * bex;
    ahi = c - (c - bex);
    alo = bex - ahi;
    c = splitter * cey;
    bhi = c - (c - cey);
    blo = cey - bhi;
    bexcey0 = alo * blo - (bexcey1 - ahi * bhi - alo * bhi - ahi * blo);
    cexbey1 = cex * bey;
    c = splitter * cex;
    ahi = c - (c - cex);
    alo = cex - ahi;
    c = splitter * bey;
    bhi = c - (c - bey);
    blo = bey - bhi;
    cexbey0 = alo * blo - (cexbey1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = bexcey0 - cexbey0;
    bvirt = bexcey0 - _i;
    bc[0] = bexcey0 - (_i + bvirt) + (bvirt - cexbey0);
    _j = bexcey1 + _i;
    bvirt = _j - bexcey1;
    _0 = bexcey1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - cexbey1;
    bvirt = _0 - _i;
    bc[1] = _0 - (_i + bvirt) + (bvirt - cexbey1);
    bc3 = _j + _i;
    bvirt = bc3 - _j;
    bc[2] = _j - (bc3 - bvirt) + (_i - bvirt);
    bc[3] = bc3;

    cexdey1 = cex * dey;
    c = splitter * cex;
    ahi = c - (c - cex);
    alo = cex - ahi;
    c = splitter * dey;
    bhi = c - (c - dey);
    blo = dey - bhi;
    cexdey0 = alo * blo - (cexdey1 - ahi * bhi - alo * bhi - ahi * blo);
    dexcey1 = dex * cey;
    c = splitter * dex;
    ahi = c - (c - dex);
    alo = dex - ahi;
    c = splitter * cey;
    bhi = c - (c - cey);
    blo = cey - bhi;
    dexcey0 = alo * blo - (dexcey1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = cexdey0 - dexcey0;
    bvirt = cexdey0 - _i;
    cd[0] = cexdey0 - (_i + bvirt) + (bvirt - dexcey0);
    _j = cexdey1 + _i;
    bvirt = _j - cexdey1;
    _0 = cexdey1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - dexcey1;
    bvirt = _0 - _i;
    cd[1] = _0 - (_i + bvirt) + (bvirt - dexcey1);
    cd3 = _j + _i;
    bvirt = cd3 - _j;
    cd[2] = _j - (cd3 - bvirt) + (_i - bvirt);
    cd[3] = cd3;

    dexaey1 = dex * aey;
    c = splitter * dex;
    ahi = c - (c - dex);
    alo = dex - ahi;
    c = splitter * aey;
    bhi = c - (c - aey);
    blo = aey - bhi;
    dexaey0 = alo * blo - (dexaey1 - ahi * bhi - alo * bhi - ahi * blo);
    aexdey1 = aex * dey;
    c = splitter * aex;
    ahi = c - (c - aex);
    alo = aex - ahi;
    c = splitter * dey;
    bhi = c - (c - dey);
    blo = dey - bhi;
    aexdey0 = alo * blo - (aexdey1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = dexaey0 - aexdey0;
    bvirt = dexaey0 - _i;
    da[0] = dexaey0 - (_i + bvirt) + (bvirt - aexdey0);
    _j = dexaey1 + _i;
    bvirt = _j - dexaey1;
    _0 = dexaey1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - aexdey1;
    bvirt = _0 - _i;
    da[1] = _0 - (_i + bvirt) + (bvirt - aexdey1);
    da3 = _j + _i;
    bvirt = da3 - _j;
    da[2] = _j - (da3 - bvirt) + (_i - bvirt);
    da[3] = da3;

    aexcey1 = aex * cey;
    c = splitter * aex;
    ahi = c - (c - aex);
    alo = aex - ahi;
    c = splitter * cey;
    bhi = c - (c - cey);
    blo = cey - bhi;
    aexcey0 = alo * blo - (aexcey1 - ahi * bhi - alo * bhi - ahi * blo);
    cexaey1 = cex * aey;
    c = splitter * cex;
    ahi = c - (c - cex);
    alo = cex - ahi;
    c = splitter * aey;
    bhi = c - (c - aey);
    blo = aey - bhi;
    cexaey0 = alo * blo - (cexaey1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = aexcey0 - cexaey0;
    bvirt = aexcey0 - _i;
    ac[0] = aexcey0 - (_i + bvirt) + (bvirt - cexaey0);
    _j = aexcey1 + _i;
    bvirt = _j - aexcey1;
    _0 = aexcey1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - cexaey1;
    bvirt = _0 - _i;
    ac[1] = _0 - (_i + bvirt) + (bvirt - cexaey1);
    ac3 = _j + _i;
    bvirt = ac3 - _j;
    ac[2] = _j - (ac3 - bvirt) + (_i - bvirt);
    ac[3] = ac3;

    bexdey1 = bex * dey;
    c = splitter * bex;
    ahi = c - (c - bex);
    alo = bex - ahi;
    c = splitter * dey;
    bhi = c - (c - dey);
    blo = dey - bhi;
    bexdey0 = alo * blo - (bexdey1 - ahi * bhi - alo * bhi - ahi * blo);
    dexbey1 = dex * bey;
    c = splitter * dex;
    ahi = c - (c - dex);
    alo = dex - ahi;
    c = splitter * bey;
    bhi = c - (c - bey);
    blo = bey - bhi;
    dexbey0 = alo * blo - (dexbey1 - ahi * bhi - alo * bhi - ahi * blo);
    _i = bexdey0 - dexbey0;
    bvirt = bexdey0 - _i;
    bd[0] = bexdey0 - (_i + bvirt) + (bvirt - dexbey0);
    _j = bexdey1 + _i;
    bvirt = _j - bexdey1;
    _0 = bexdey1 - (_j - bvirt) + (_i - bvirt);
    _i = _0 - dexbey1;
    bvirt = _0 - _i;
    bd[1] = _0 - (_i + bvirt) + (bvirt - dexbey1);
    bd3 = _j + _i;
    bvirt = bd3 - _j;
    bd[2] = _j - (bd3 - bvirt) + (_i - bvirt);
    bd[3] = bd3;

    temp8alen = scale_expansion_zeroelim(4, cd, bez, temp8a);
    temp8blen = scale_expansion_zeroelim(4, bd, -cez, temp8b);
    temp8clen = scale_expansion_zeroelim(4, bc, dez, temp8c);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, aex, temp48);
    xlen = scale_expansion_zeroelim(temp48len, temp48, -aex, xdet);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, aey, temp48);
    ylen = scale_expansion_zeroelim(temp48len, temp48, -aey, ydet);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, aez, temp48);
    zlen = scale_expansion_zeroelim(temp48len, temp48, -aez, zdet);
    xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet);
    const alen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, adet);

    temp8alen = scale_expansion_zeroelim(4, da, cez, temp8a);
    temp8blen = scale_expansion_zeroelim(4, ac, dez, temp8b);
    temp8clen = scale_expansion_zeroelim(4, cd, aez, temp8c);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, bex, temp48);
    xlen = scale_expansion_zeroelim(temp48len, temp48, bex, xdet);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, bey, temp48);
    ylen = scale_expansion_zeroelim(temp48len, temp48, bey, ydet);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, bez, temp48);
    zlen = scale_expansion_zeroelim(temp48len, temp48, bez, zdet);
    xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet);
    const blen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, bdet);

    temp8alen = scale_expansion_zeroelim(4, ab, dez, temp8a);
    temp8blen = scale_expansion_zeroelim(4, bd, aez, temp8b);
    temp8clen = scale_expansion_zeroelim(4, da, bez, temp8c);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, cex, temp48);
    xlen = scale_expansion_zeroelim(temp48len, temp48, -cex, xdet);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, cey, temp48);
    ylen = scale_expansion_zeroelim(temp48len, temp48, -cey, ydet);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, cez, temp48);
    zlen = scale_expansion_zeroelim(temp48len, temp48, -cez, zdet);
    xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet);
    const clen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, cdet);

    temp8alen = scale_expansion_zeroelim(4, bc, aez, temp8a);
    temp8blen = scale_expansion_zeroelim(4, ac, -bez, temp8b);
    temp8clen = scale_expansion_zeroelim(4, ab, cez, temp8c);
    temp16len = fast_expansion_sum_zeroelim(temp8alen, temp8a, temp8blen, temp8b, temp16);
    temp24len = fast_expansion_sum_zeroelim(temp8clen, temp8c, temp16len, temp16, temp24);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, dex, temp48);
    xlen = scale_expansion_zeroelim(temp48len, temp48, dex, xdet);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, dey, temp48);
    ylen = scale_expansion_zeroelim(temp48len, temp48, dey, ydet);
    temp48len = scale_expansion_zeroelim(temp24len, temp24, dez, temp48);
    zlen = scale_expansion_zeroelim(temp48len, temp48, dez, zdet);
    xylen = fast_expansion_sum_zeroelim(xlen, xdet, ylen, ydet, xydet);
    const dlen = fast_expansion_sum_zeroelim(xylen, xydet, zlen, zdet, ddet);

    const ablen = fast_expansion_sum_zeroelim(alen, adet, blen, bdet, abdet);
    const cdlen = fast_expansion_sum_zeroelim(clen, cdet, dlen, ddet, cddet);
    const finlength = fast_expansion_sum_zeroelim(ablen, abdet, cdlen, cddet, fin1);

    let det = estimate(finlength, fin1);
    let errbound = isperrboundB * permanent;
    if (det >= errbound || -det >= errbound) {
        return det;
    }

    bvirt = ax - aex;
    aextail = ax - (aex + bvirt) + (bvirt - ex);
    bvirt = ay - aey;
    aeytail = ay - (aey + bvirt) + (bvirt - ey);
    bvirt = az - aez;
    aeztail = az - (aez + bvirt) + (bvirt - ez);
    bvirt = bx - bex;
    bextail = bx - (bex + bvirt) + (bvirt - ex);
    bvirt = by - bey;
    beytail = by - (bey + bvirt) + (bvirt - ey);
    bvirt = bz - bez;
    beztail = bz - (bez + bvirt) + (bvirt - ez);
    bvirt = cx - cex;
    cextail = cx - (cex + bvirt) + (bvirt - ex);
    bvirt = cy - cey;
    ceytail = cy - (cey + bvirt) + (bvirt - ey);
    bvirt = cz - cez;
    ceztail = cz - (cez + bvirt) + (bvirt - ez);
    bvirt = dx - dex;
    dextail = dx - (dex + bvirt) + (bvirt - ex);
    bvirt = dy - dey;
    deytail = dy - (dey + bvirt) + (bvirt - ey);
    bvirt = dz - dez;
    deztail = dz - (dez + bvirt) + (bvirt - ez);
    if (aextail === 0 && aeytail === 0 && aeztail === 0 &&
        bextail === 0 && beytail === 0 && beztail === 0 &&
        cextail === 0 && ceytail === 0 && ceztail === 0 &&
        dextail === 0 && deytail === 0 && deztail === 0) {
        return det;
    }

    errbound = isperrboundC * permanent + resulterrbound * Math.abs(det);

    const abeps = (aex * beytail + bey * aextail) - (aey * bextail + bex * aeytail);
    const bceps = (bex * ceytail + cey * bextail) - (bey * cextail + cex * beytail);
    const cdeps = (cex * deytail + dey * cextail) - (cey * dextail + dex * ceytail);
    const daeps = (dex * aeytail + aey * dextail) - (dey * aextail + aex * deytail);
    const aceps = (aex * ceytail + cey * aextail) - (aey * cextail + cex * aeytail);
    const bdeps = (bex * deytail + dey * bextail) - (bey * dextail + dex * beytail);
    det +=
        (((bex * bex + bey * bey + bez * bez) * ((cez * daeps + dez * aceps + aez * cdeps) +
        (ceztail * da3 + deztail * ac3 + aeztail * cd3)) + (dex * dex + dey * dey + dez * dez) *
        ((aez * bceps - bez * aceps + cez * abeps) + (aeztail * bc3 - beztail * ac3 + ceztail * ab3))) -
        ((aex * aex + aey * aey + aez * aez) * ((bez * cdeps - cez * bdeps + dez * bceps) +
        (beztail * cd3 - ceztail * bd3 + deztail * bc3)) + (cex * cex + cey * cey + cez * cez) *
        ((dez * abeps + aez * bdeps + bez * daeps) + (deztail * ab3 + aeztail * bd3 + beztail * da3)))) +
        2 * (((bex * bextail + bey * beytail + bez * beztail) * (cez * da3 + dez * ac3 + aez * cd3) +
        (dex * dextail + dey * deytail + dez * deztail) * (aez * bc3 - bez * ac3 + cez * ab3)) -
        ((aex * aextail + aey * aeytail + aez * aeztail) * (bez * cd3 - cez * bd3 + dez * bc3) +
        (cex * cextail + cey * ceytail + cez * ceztail) * (dez * ab3 + aez * bd3 + bez * da3)));

    if (det >= errbound || -det >= errbound) {
        return det;
    }

    return insphereexact(ax, ay, az, bx, by, bz, cx, cy, cz, dx, dy, dz, ex, ey, ez);
}

export function insphere(ax, ay, az, bx, by, bz, cx, cy, cz, dx, dy, dz, ex, ey, ez) {
    const aex = ax - ex;
    const bex = bx - ex;
    const cex = cx - ex;
    const dex = dx - ex;
    const aey = ay - ey;
    const bey = by - ey;
    const cey = cy - ey;
    const dey = dy - ey;
    const aez = az - ez;
    const bez = bz - ez;
    const cez = cz - ez;
    const dez = dz - ez;

    const aexbey = aex * bey;
    const bexaey = bex * aey;
    const ab = aexbey - bexaey;
    const bexcey = bex * cey;
    const cexbey = cex * bey;
    const bc = bexcey - cexbey;
    const cexdey = cex * dey;
    const dexcey = dex * cey;
    const cd = cexdey - dexcey;
    const dexaey = dex * aey;
    const aexdey = aex * dey;
    const da = dexaey - aexdey;

    const aexcey = aex * cey;
    const cexaey = cex * aey;
    const ac = aexcey - cexaey;
    const bexdey = bex * dey;
    const dexbey = dex * bey;
    const bd = bexdey - dexbey;

    const abc = aez * bc - bez * ac + cez * ab;
    const bcd = bez * cd - cez * bd + dez * bc;
    const cda = cez * da + dez * ac + aez * cd;
    const dab = dez * ab + aez * bd + bez * da;

    const alift = aex * aex + aey * aey + aez * aez;
    const blift = bex * bex + bey * bey + bez * bez;
    const clift = cex * cex + cey * cey + cez * cez;
    const dlift = dex * dex + dey * dey + dez * dez;

    const det = (clift * dab - dlift * abc) + (alift * bcd - blift * cda);

    const aezplus = Math.abs(aez);
    const bezplus = Math.abs(bez);
    const cezplus = Math.abs(cez);
    const dezplus = Math.abs(dez);
    const aexbeyplus = Math.abs(aexbey);
    const bexaeyplus = Math.abs(bexaey);
    const bexceyplus = Math.abs(bexcey);
    const cexbeyplus = Math.abs(cexbey);
    const cexdeyplus = Math.abs(cexdey);
    const dexceyplus = Math.abs(dexcey);
    const dexaeyplus = Math.abs(dexaey);
    const aexdeyplus = Math.abs(aexdey);
    const aexceyplus = Math.abs(aexcey);
    const cexaeyplus = Math.abs(cexaey);
    const bexdeyplus = Math.abs(bexdey);
    const dexbeyplus = Math.abs(dexbey);
    const permanent =
        ((cexdeyplus + dexceyplus) * bezplus + (dexbeyplus + bexdeyplus) * cezplus + (bexceyplus + cexbeyplus) * dezplus) * alift +
        ((dexaeyplus + aexdeyplus) * cezplus + (aexceyplus + cexaeyplus) * dezplus + (cexdeyplus + dexceyplus) * aezplus) * blift +
        ((aexbeyplus + bexaeyplus) * dezplus + (bexdeyplus + dexbeyplus) * aezplus + (dexaeyplus + aexdeyplus) * bezplus) * clift +
        ((bexceyplus + cexbeyplus) * aezplus + (cexaeyplus + aexceyplus) * bezplus + (aexbeyplus + bexaeyplus) * cezplus) * dlift;

    const errbound = isperrboundA * permanent;
    if (det > errbound || -det > errbound) {
        return det;
    }
    return -insphereadapt(ax, ay, az, bx, by, bz, cx, cy, cz, dx, dy, dz, ex, ey, ez, permanent);
}

export function inspherefast(pax, pay, paz, pbx, pby, pbz, pcx, pcy, pcz, pdx, pdy, pdz, pex, pey, pez) {
    const aex = pax - pex;
    const bex = pbx - pex;
    const cex = pcx - pex;
    const dex = pdx - pex;
    const aey = pay - pey;
    const bey = pby - pey;
    const cey = pcy - pey;
    const dey = pdy - pey;
    const aez = paz - pez;
    const bez = pbz - pez;
    const cez = pcz - pez;
    const dez = pdz - pez;

    const ab = aex * bey - bex * aey;
    const bc = bex * cey - cex * bey;
    const cd = cex * dey - dex * cey;
    const da = dex * aey - aex * dey;

    const ac = aex * cey - cex * aey;
    const bd = bex * dey - dex * bey;

    const abc = aez * bc - bez * ac + cez * ab;
    const bcd = bez * cd - cez * bd + dez * bc;
    const cda = cez * da + dez * ac + aez * cd;
    const dab = dez * ab + aez * bd + bez * da;

    const alift = aex * aex + aey * aey + aez * aez;
    const blift = bex * bex + bey * bey + bez * bez;
    const clift = cex * cex + cey * cey + cez * cez;
    const dlift = dex * dex + dey * dey + dez * dez;

    return (clift * dab - dlift * abc) + (alift * bcd - blift * cda);
}
